Public Class Form1

    Dim tcpClient As New System.Net.Sockets.TcpClient()
    Dim telnet_console As String
    Dim nowPlaying As String

    Sub read()
        Dim networkStream As System.Net.Sockets.NetworkStream = tcpClient.GetStream()

        If networkStream.CanWrite And networkStream.CanRead Then

            If networkStream.DataAvailable = True Then

                Dim myReadBuffer(1024) As Byte
                Dim myCompleteMessage As System.Text.StringBuilder = New System.Text.StringBuilder()
                Dim numberOfBytesRead As Integer = 0

                ' Incoming message may be larger than the buffer size.
                Do
                    numberOfBytesRead = networkStream.Read(myReadBuffer, 0, myReadBuffer.Length)
                    myCompleteMessage.AppendFormat("{0}", System.Text.Encoding.ASCII.GetString(myReadBuffer, 0, numberOfBytesRead))
                Loop While networkStream.DataAvailable

                Me.TelnetConsole.AppendText(myCompleteMessage.ToString())

            End If
        End If
    End Sub

    Private Sub Login()
        Dim networkStream As System.Net.Sockets.NetworkStream = tcpClient.GetStream()
 
        Dim sendBytes As [Byte]() = System.Text.Encoding.ASCII.GetBytes("v" & Chr(13) & Chr(10))
        networkStream.Write(sendBytes, 0, sendBytes.Length)

    End Sub

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        tcpClient.Connect("192.168.0.11", 4212)
        TelnetConsole.Text = "Connecting.." & Chr(13)
        read()
        Login()
        UpdateChannels()
    End Sub

    Private Sub UpdateChannels()
        Dim networkStream As System.Net.Sockets.NetworkStream = tcpClient.GetStream()

        If networkStream.CanWrite And networkStream.CanRead Then

            Dim MyReader As New Microsoft.VisualBasic.FileIO.TextFieldParser("channels.conf")
            Dim currentRow As String()
            Dim fieldCount = 0
            Dim buffer As String
            Dim channelName As String
            Dim channelFrequency As String
            Dim channelNumber As String
            Dim dvbSymbolrate As String
            Dim dvbModulation As String
            Dim operatingMode As String

            operatingMode = "DVBC"

            buffer = "del all" & Chr(13) & Chr(10)
            channelName = ""
            channelFrequency = ""
            channelNumber = ""
            dvbModulation = ""
            dvbSymbolrate = ""

            Dim sendBytes As [Byte]()

            MyReader.TextFieldType = FileIO.FieldType.Delimited
            MyReader.SetDelimiters(":")

            While Not MyReader.EndOfData
                Try

                    currentRow = MyReader.ReadFields()
                    Dim currentField As String
                    For Each currentField In currentRow


                        If operatingMode = "DVBT" Then

                            If fieldCount = 0 Then
                                channelName = Replace(currentField, " ", "")
                            End If

                            If fieldCount = 12 Then
                                channelNumber = currentField
                            End If

                            If fieldCount = 1 Then
                                channelFrequency = currentField
                            End If

                            fieldCount = fieldCount + 1

                            If fieldCount > 12 Then

                                fieldCount = 0
                                buffer = buffer + "new " + channelName + " broadcast enabled" & Chr(13) & Chr(10)
                                buffer = buffer + "setup " + channelName + " input ""dvb://""" & Chr(13) & Chr(10)
                                buffer = buffer + "setup " + channelName + " option dvb-adapter=0" & Chr(13) & Chr(10)
                                buffer = buffer + "setup " + channelName + " option dvb-frequency=" + channelFrequency + "" & Chr(13) & Chr(10)
                                buffer = buffer + "setup " + channelName + " option dvb-transmission=8" & Chr(13) & Chr(10)
                                buffer = buffer + "setup " + channelName + " option dvb-guard=8" & Chr(13) & Chr(10)
                                buffer = buffer + "setup " + channelName + " option dvb-hierarchy=-1" & Chr(13) & Chr(10)
                                buffer = buffer + "setup " + channelName + " option dvb-bandwidth=8" & Chr(13) & Chr(10)
                                buffer = buffer + "setup " + channelName + " option program=" + channelNumber + "" & Chr(13) & Chr(10)
                                buffer = buffer + "setup " + channelName + " option standard-mux=ps" & Chr(13) & Chr(10)
                                buffer = buffer + "setup " + channelName + " output #standard{access=http,mux=ps,dst=192.168.0.11:8080}" & Chr(13) & Chr(10)
                                ChannelList.Items.Add(channelName)
                            End If


                        End If



                        If operatingMode = "DVBC" Then

                            If fieldCount = 0 Then
                                channelName = Replace(currentField, " ", "")
                            End If

                            If fieldCount = 8 Then
                                channelNumber = currentField
                            End If

                            If fieldCount = 1 Then
                                channelFrequency = currentField
                            End If

                            If fieldCount = 5 Then
                                dvbModulation = Replace(currentField, "QAM_", "")
                            End If

                            If fieldCount = 3 Then
                                dvbSymbolrate = currentField
                            End If

                            fieldCount = fieldCount + 1


                            If fieldCount > 8 Then

                                fieldCount = 0
                                buffer = buffer + "new " + channelName + " broadcast enabled" & Chr(13) & Chr(10)
                                buffer = buffer + "setup " + channelName + " input ""dvb://""" & Chr(13) & Chr(10)
                                buffer = buffer + "setup " + channelName + " option dvb-adapter=0" & Chr(13) & Chr(10)
                                buffer = buffer + "setup " + channelName + " option dvb-frequency=" + channelFrequency + "" & Chr(13) & Chr(10)
                                buffer = buffer + "setup " + channelName + " option dvb-modulation=" + dvbModulation + "" & Chr(13) & Chr(10)
                                buffer = buffer + "setup " + channelName + " option dvb-srate=" + dvbSymbolrate + "" & Chr(13) & Chr(10)
                                buffer = buffer + "setup " + channelName + " option program=" + channelNumber + "" & Chr(13) & Chr(10)
                                buffer = buffer + "setup " + channelName + " option standard-mux=ps" & Chr(13) & Chr(10)
                                buffer = buffer + "setup " + channelName + " output #standard{access=http,mux=ps,dst=192.168.0.11:8080}" & Chr(13) & Chr(10)
                                ChannelList.Items.Add(channelName)
                            End If

                        End If








                    Next

                Catch ex As _
                Microsoft.VisualBasic.FileIO.MalformedLineException
                    MsgBox("Line " & ex.Message & _
                    "is not valid and will be skipped.")
                End Try
            End While

            sendBytes = System.Text.Encoding.ASCII.GetBytes(buffer)
            networkStream.Write(sendBytes, 0, sendBytes.Length)

            TelnetConsole.AppendText(buffer)

        End If
    End Sub


    Private Sub ChannelList_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ChannelList.SelectedIndexChanged

        Dim networkStream As System.Net.Sockets.NetworkStream = tcpClient.GetStream()
        Dim buffer As String
        Dim sendBytes As [Byte]() = System.Text.Encoding.ASCII.GetBytes("")

        buffer = "control " + nowPlaying + " stop" & Chr(13) & Chr(10)
        sendBytes = System.Text.Encoding.ASCII.GetBytes(buffer)
        networkStream.Write(sendBytes, 0, sendBytes.Length)
        TelnetConsole.AppendText(buffer)

        buffer = "control " + ChannelList.SelectedItem + " play" & Chr(13) & Chr(10)
        sendBytes = System.Text.Encoding.ASCII.GetBytes(buffer)
        networkStream.Write(sendBytes, 0, sendBytes.Length)
        TelnetConsole.AppendText(buffer)

        nowPlaying = ChannelList.SelectedItem

        Shell("""C:\Program Files\VideoLAN\VLC\VLC.exe"" -vvv http://192.168.0.11:8080 vlc://quit", vbNormalFocus)

    End Sub

    Private Sub RecordButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RecordButton.Click

        Dim TimeSTring As String
        TimeSTring = Replace(Date.Now, ":", ".")

        Shell("""C:\Program Files\VideoLAN\VLC\VLC.exe"" -vvv http://192.168.0.11:8080 --sout #duplicate{dst=std{access=file,mux=ps,dst=""c:\" + nowPlaying + " " + TimeSTring + ".mpg""}}", vbNormalFocus)
    End Sub
End Class